%define _unpackaged_files_terminate_build 0
%define _missing_doc_files_terminate_build 0

Name: xen
Version: 4.3.0
Release: 55%{?dist}
Summary: Xen virtual machine monitor
Group: Development/Libraries
License: GPL
URL: http://www.xenproject.org/
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
Source0: xen-4.3.0.tar.gz
Patch1: dummy.patch
Patch2: ovs-xen-use-local-qemu.patch
Patch3: ovs-xen-bootloader-acquire-released-lock-on-failure.patch
Patch4: ovs-xen-add-domain-running-lock-callout-hook.patch
Patch5: ovs-xen-set-max-cstate-to-1.patch
Patch6: ovs-xen-increase-max-grant-frames.patch
Patch7: ovs-xen-avoid-concurrent-calls-to-destroy-same-domain.patch
Patch8: ovs-xen-fix-file-descriptor-leak-in-ssl-migration.patch
Patch9: ovs-xen-setup-dmnfs-device-mapper-for-files-on-nfs.patch
Patch10: ovs-xen-fix-dom0-ballooning-when-dom-min-mem-set.patch
Patch11: ovs-xen-xend-config-enable-ssl-relocation-server.patch
Patch12: ovs-xen-tools-dom0-min-mem-disable-ballooning.patch
Patch13: ovs-xen-disable-network-script.patch
Patch14: ovs-xen-version-includes-ovm.patch
Patch15: ovs-xen-xm-reboot-wait.patch
Patch16: ovs-xen-xend-disable-pvscsi.patch
Patch17: ovs-xen-xm-create-vcpu-avail-exceeds-xmlrpc-limits.patch
Patch18: ovs-xen-fix-bootloader-hang.patch
Patch19: ovs-xen-block-create-loop-dev.patch
Patch20: ovs-xen-remove-unnecessary-balloon-retries.patch
Patch21: ovs-xen-expose-host-uuid.patch
Patch22: ovs-xen-revert-xen-unstable-cs-22315.patch
Patch23: ovs-xen-prevent-guests-from-hanging-on-reboot.patch
Patch24: ovs-xen-disable-iptables-when-adding-vif-to-bridge.patch
Patch25: ovs-xen-add-support-for-openvswitch.patch
Patch26: ovs-xen-add-vif-switch-to-makefile.patch
Patch27: ovs-xen-disable-netfilter-on-bridges.patch
Patch28: ovs-xen-disable-multicast-snooping.patch
Patch29: ovs-xen-add-allowhugepage-flag.patch
Patch30: Bug16721961.patch
Patch31: rev6428.patch
Patch32: rev6460.patch
Patch33: ovs-xen-put-xenstored-tdb-to-tmpfs.patch
Patch34: ple-patch.patch
Patch35: 17892410_patch.txt.patch
Patch36: rev6644.patch
Patch37: rev6655.patch
Patch38: Xend-handle-died-domain-in-getVCPUInfo.patch
Patch39: rev6669.patch
Patch40: rev6679.patch
Patch41: prevent-output-to-stdout.patch
Patch42: xsa73-xen-4.3.patch
Patch43: xsa74-xen-4.3.patch
Patch44: xsa75-xen-4.3.patch
Patch45: xsa76-xen-4.3.patch
Patch46: xsa78-xen-4.3.patch
Patch47: xsa80-xen-4.3.patch
Patch48: xsa82-xen-4.3.patch
Patch49: xsa60-xen-4.3.patch
Patch50: create_xendomains_lockfile.patch
Patch51: libxenctrl-Fix-xc_interface_close-crash-if-it-gets-N.patch
Patch52: x86-fix-early-boot-command-line-parsing.patch
Patch53: kexec-x86-do-not-map-crash-kernel-area.patch
Patch54: ovs-xen-disable-restore-domains.patch
Patch55: bridge-or-vsw.patch
Patch56: xsa-83.patch
Patch57: xsa-84.patch
Patch58: xsa-85.patch
Patch59: xsa-86.patch
Patch60: xsa-87.patch
Patch61: xsa-88.patch
Patch62: sriov_64bit_mem_space.patch
Patch63: rev6885.patch
Patch64: rev6901.patch
Patch65: rev6909.patch
Patch66: ol7-vm.patch
Patch67: free-pirqs.patch
Patch68: xsa-89.patch
Patch69: 18552539.patch
Patch70: xen-make_dom0_mem_augment_the_nr_pages.patch
Patch71: disable_domain_save.patch
Patch72: xsa-92.patch
Patch73: use_native_tsc.patch
Patch74: tsc_scaling.patch
Patch75: iommu_set_correct_IOMMU_entries_when_iommu_hap_pt_share_off.patch
Patch76: use_fixed_tsc_lm.patch
# End Oracle Patches

BuildRequires: transfig libidn-devel zlib-devel curl-devel
BuildRequires: python-devel ghostscript tetex-latex gettext
BuildRequires: ncurses-devel libaio-devel libxml2-devel
BuildRequires: flex bison pciutils-devel libuuid-devel SDL-devel openssl-devel
BuildRequires: yajl-devel
BuildRequires: libuuid-devel
BuildRequires: e2fsprogs-devel
BuildRequires: ocaml ocaml-findlib
# for the docs 
BuildRequires: perl 
# so that the makefile knows to install udev rules
BuildRequires: udev 
BuildRequires: texi2html imake
# need this level for modprobe --dump-modversions
BuildRequires: module-init-tools >= 3.3-0.pre3.1.16
BuildRequires: dev86
BuildRequires: iasl
Requires: bridge-utils
Requires: udev >= 059
Requires: util-linux >= 2.13-0.45
Requires: kpartx

%description
This package contains the Xen hypervisor and Xen tools, needed to
run virtual machines on x86 systems.

%package tools
Summary: Various tooling for the manipulation of Xen instances
Group: System Environment/Libraries
Requires(pre): /sbin/ldconfig 
Requires(post): /sbin/ldconfig

%description tools
This package contains the user utilities required for the manipulation
of Xen guest instances, associated documentation and keymaps.

%package devel
Summary: Development libraries for Xen tools
Group: Development/Libraries
Requires: xen-tools = %{version}-%{release}
Requires(pre): /sbin/ldconfig
Requires(post): /sbin/ldconfig

%description devel
This package contains headers and static libraries to develop applications to
manage Xen virtual machines. 

%prep
%setup -q
%patch1 -p1
%patch2 -p0
%patch3 -p0
%patch4 -p0
%patch5 -p0
%patch6 -p0
%patch7 -p0
%patch8 -p0
%patch9 -p0
%patch10 -p0
%patch11 -p0
%patch12 -p0
%patch13 -p0
%patch14 -p0
%patch15 -p0
%patch16 -p0
%patch17 -p0
%patch18 -p0
%patch19 -p0
%patch20 -p0
%patch21 -p0
%patch22 -p0
%patch23 -p0
%patch24 -p0
%patch25 -p0
%patch26 -p0
%patch27 -p0
%patch28 -p0
%patch29 -p0
%patch30 -p0
%patch31 -p0
%patch32 -p0
%patch33 -p0
%patch34 -p0
%patch35 -p0
%patch36 -p0
%patch37 -p0
%patch38 -p0
%patch39 -p0
%patch40 -p0
%patch41 -p0
%patch42 -p0
%patch43 -p0
%patch44 -p0
%patch45 -p0
%patch46 -p0
%patch47 -p0
%patch48 -p0
%patch49 -p0
%patch50 -p0
%patch51 -p1
%patch52 -p1
%patch53 -p1
%patch54 -p0
%patch55 -p0
%patch56 -p0
%patch57 -p0
%patch58 -p0
%patch59 -p0
%patch60 -p0
%patch61 -p0
%patch62 -p0
%patch63 -p0
%patch64 -p0
%patch65 -p0
%patch66 -p0
%patch67 -p0
%patch68 -p0
%patch69 -p0
%patch70 -p0
%patch71 -p0
%patch72 -p0
%patch73 -p0
%patch74 -p0
%patch75 -p0
%patch76 -p0

%build
%configure
make max_phys_cpus=240 dist-xen dist-tools

%install
make DESTDIR=$RPM_BUILD_ROOT install-xen install-tools

# Create dirs in /var
mkdir -p %{buildroot}%{_localstatedir}/lib/xen/xend-db/domain
mkdir -p %{buildroot}%{_localstatedir}/lib/xen/xend-db/vnet
mkdir -p %{buildroot}%{_localstatedir}/lib/xen/xend-db/migrate
mkdir -p %{buildroot}%{_localstatedir}/lib/xen/dump
mkdir -p %{buildroot}%{_localstatedir}/lib/xen/images
mkdir -p %{buildroot}%{_localstatedir}/log/xen/console

# Create symlink for x86_64 for compatibility with 3.4
%if "%{_libdir}" != "/usr/lib"
ln -s /usr/lib/xen/bin/qemu-dm %{buildroot}/%{_libdir}/xen/bin/qemu-dm
%endif

# Remove unused empty file
rm -f /usr/etc/qemu/target-x86_64.conf

%post
/sbin/chkconfig --add xencommons
/sbin/chkconfig --add xend
/sbin/chkconfig --add xendomains

%preun
if [ $1 = 0 ]; then
  /sbin/chkconfig --del xencommons
  /sbin/chkconfig --del xend
  /sbin/chkconfig --del xendomains
fi

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
/boot/*

%files tools
%config(noreplace) %{_sysconfdir}/xen/xend-config.sxp
%config(noreplace) %{_sysconfdir}/sysconfig/*
%{_sysconfdir}/xen
%{_sysconfdir}/bash_completion.d/xl.sh
%{_sysconfdir}/rc.d/init.d/*
%{_sysconfdir}/udev/rules.d/*.rules
%{_sbindir}/*
%{_bindir}/*

%{_libdir}/*.so
%{_libdir}/*.so.*
%{_libdir}/fs
%{_libdir}/ocaml
%{_libdir}/python*/site-packages
%{_libdir}/xen/bin/*
/usr/lib/xen/boot/hvmloader
/usr/lib/xen/bin/*

%doc COPYING README
%{_datadir}/doc/xen/
%{_mandir}/man?/*
%{_datadir}/xen/create.dtd

# QEMU
%{_datadir}/xen/qemu
%{_datadir}/qemu-xen
%{_libexecdir}/qemu-bridge-helper

# General Xen state
%dir %{_localstatedir}/xen/dump
%dir %{_localstatedir}/lib/xen
%dir %{_localstatedir}/lib/xen/dump
%dir %{_localstatedir}/lib/xen/images
%dir %{_localstatedir}/run/xen
# Xenstore persistent state
%dir %{_localstatedir}/lib/xenstored
%dir %{_localstatedir}/run/xenstored
# XenD runtime state
%dir %{_localstatedir}/lib/xen/xend-db/
%dir %{_localstatedir}/lib/xen/xend-db/domain
%dir %{_localstatedir}/lib/xen/xend-db/migrate
%dir %{_localstatedir}/lib/xen/xend-db/vnet
%dir %attr(0700,root,root) %{_localstatedir}/run/xend
%dir %attr(0700,root,root) %{_localstatedir}/run/xend/boot
# Xen logfiles
%dir %attr(0700,root,root) %{_localstatedir}/log/xen
# Guest/HV console logs
%dir %attr(0700,root,root) %{_localstatedir}/log/xen/console

%files devel
%defattr(-,root,root)
%{_includedir}/
%{_libdir}/*.a

%changelog
* Wed May 14 2014 Boris Ostrovsky <boris.ostrovsky@oracle.com> - 4.3.0-55 
- x86/HVM: use fixed TSC value when saving or restoring domain
  
  When a domain is saved each VCPU's TSC value needs to be preserved. To get it we
  use hvm_get_guest_tsc(). This routine (either itself or via get_s_time() which
  it may call) calculates VCPU's TSC based on current host's TSC value (by doing a
  rdtscll()). Since this is performed for each VCPU separately we end up with
  un-synchronized TSCs.
  
  Similarly, during a restore each VCPU is assigned its TSC based on host's current
  tick, causing virtual TSCs to diverge further.
  
  With this, we can easily get into situation where a guest may see time going
  backwards.
  
  Instead of reading new TSC value for each VCPU when saving/restoring it we should
  use the same value across all VCPUs.
  
  Reported-by: Philippe Coquard <philippe.coquard@mpsa.com>
  Signed-off-by: Boris Ostrovsky <boris.ostrovsky@oracle.com>
  Reviewed-by: Jan Beulich <jbeulich@suse.com>
  commit: 88e64cb785c1de4f686c1aa1993a0003b7db9e1a [bug 18755631]  

* Wed May 14 2014 Konrad Wilk <konrad.wilk@oracle.com> - 4.3.0-54 
- iommu: set correct IOMMU entries when iommu_hap_pt_share == 0
  If the memory map is not shared between HAP and IOMMU we fail to set
  correct IOMMU mappings for memory types other than p2m_ram_rw.
  This patchs adds IOMMU support for the following memory types:
  p2m_grant_map_rw, p2m_map_foreign, p2m_ram_ro, p2m_grant_map_ro and
  p2m_ram_logdirty.
  Signed-off-by: Roger Pau Monn?195?169 <roger.pau@citrix.com>
  Cc: Tim Deegan <tim@xen.org>
  Cc: Jan Beulich <jbeulich@suse.com>
  Tested-by: David Zhuang <david.zhuang@oracle.com>
  ---
  Changes since v1:
  - Move the p2m type switch to IOMMU flags to an inline function that
  is shared between p2m-ept and p2m-pt.
  - Make p2m_set_entry also use p2m_get_iommu_flags.
  ---
  When backporting this patch it would not apply cleanly due to two commits
  not existing in the Xen 4.3 repo:
  commit 243cebb3dfa1f94ec7c2b040e8fd15ae4d81cc5a
  Author: Mukesh Rathor <mukesh.rathor@oracle.com>
  Date:   Thu Apr 17 10:05:07 2014 +0200
  pvh dom0: introduce p2m_map_foreign
  [adds the p2m_map_foreign type]
  commit 3d8d2bd048773ababfa65cc8781b9ab3f5cf0eb0
  Author: Jan Beulich <jbeulich@suse.com>
  Date:   Fri Mar 28 13:37:10 2014 +0100
  x86/EPT: simplification and cleanup
  [simplifies the loop in ept_set_entry]
  As such the original patch from
  http://lists.xen.org/archives/html/xen-devel/2014-04/msg02928.html
  has been slightly changed.
  Signed-off-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com> [bug 17789939]  

* Wed May 14 2014 Boris Ostrovsky <boris.ostrovsky@oracle.com> - 4.3.0-53 
- x86/svm: enable TSC scaling
  
  TSC ratio enabling logic is inverted: we want to use it when we
  are running in native tsc mode, i.e. when d->arch.vtsc is zero.
  
  Also, since now svm_set_tsc_offset()'s calculations depend
  on vtsc's value, we need to call hvm_funcs.set_tsc_offset() after
  vtsc changes in tsc_set_info().
  
  In addition, with TSC ratio enabled, svm_set_tsc_offset() will
  need to do rdtsc. With that we may end up having TSCs on guest's
  processors out of sync. d->arch.hvm_domain.sync_tsc which is set
  by the boot processor can now be used by APs as reference TSC
  value instead of host's current TSC.
  
  Signed-off-by: Boris Ostrovsky <boris.ostrovsky@oracle.com>
  Reviewed-by: Jan Beulich <jbeulich@suse.com>
  commit: b95fd03b5f0b66384bd7c190d5861ae68eb98c85 [bug 18755631]  

* Wed May 14 2014 Boris Ostrovsky <boris.ostrovsky@oracle.com> - 4.3.0-52 
- x86: use native RDTSC(P) execution when guest and host frequencies are the same
  We should be able to continue using native RDTSC(P) execution on
  HVM/PVH guests after migration if host and guest frequencies are
  equal (this includes the case when the frequencies are made equal
  by TSC scaling feature).
  
  This also allows us to revert main part of commit 4aab59a3 (svm: Do not
  intercept RDTSC(P) when TSC scaling is supported by hardware) which
  was wrong: while RDTSC intercepts were disabled domain's vtsc could
  still be set, leading to inconsistent view of guest's TSC.
  
  Signed-off-by: Boris Ostrovsky <boris.ostrovsky@oracle.com>
  Acked-by: Jan Beulich <jbeulich@suse.com>
  commit: 82713ec8d2b65d17f13e46a131e38bfe5baf8bd6 [bug 18755631]  

* Fri May 02 2014 Boris Ostrovsky <boris.ostrovsky@oracle.com> - 4.3.0-51 
- x86/HVM: restrict HVMOP_set_mem_type
  Xen Security Advisory CVE-2014-3124 / XSA-92
  version 3
  HVMOP_set_mem_type allows invalid P2M entries to be created
  UPDATES IN VERSION 3
  ====================
  This issue has been assigned CVE-2014-3124.
  ISSUE DESCRIPTION
  =================
  The implementation in Xen of the HVMOP_set_mem_type HVM control
  operations attempts to exclude transitioning a page from an
  inappropriate memory type.  However, only an inadequate subset of
  memory types is excluded.
  There are certain other types that don't correspond to a particular
  valid page, whose page table translation can be inappropriately
  changed (by HVMOP_set_mem_type) from not-present (due to the lack of
  valid memory page) to present.  If this occurs, an invalid translation
  will be established.
  IMPACT
  ======
  In a configuration where device models run with limited privilege (for
  example, stubdom device models), a guest attacker who successfully
  finds and exploits an unfixed security flaw in qemu-dm could leverage
  the other flaw into a Denial of Service affecting the whole host.
  In the more general case, in more abstract terms: a malicious
  administrator of a domain privileged with regard to an HVM guest can
  cause Xen to crash leading to a Denial of Service.
  Arbitrary code execution, and therefore privilege escalation, cannot
  be entirely excluded: On a system with a RAM page present immediately
  below the 52-bit address boundary, this would be possible.  However,
  we are not aware of any systems with such a memory layout.
  VULNERABLE SYSTEMS
  ==================
  All Xen versions from 4.1 onwards are vulnerable.
  The vulnerability is only exposed to service domains for HVM guests
  which have privilege over the guest.  In a usual configuration that
  means only device model emulators (qemu-dm).
  In the case of HVM guests whose device model is running in an
  unrestricted dom0 process, qemu-dm already has the ability to cause
  problems for the whole system.  So in that case the vulnerability is
  not applicable.
  The situation is more subtle for an HVM guest with a stub qemu-dm.
  That is, where the device model runs in a separate domain (in the case
  of xl, as requested by "device_model_stubdomain_override=1" in the xl
  domain configuration file).  The same applies with a qemu-dm in a dom0
  process subjected to some kind kernel-based process privilege
  limitation (eg the chroot technique as found in some versions of
  XCP/XenServer).
  In those latter situations this issue means that the extra isolation
  does not provide as good a defence (against denial of service) as
  intended.  That is the essence of this vulnerability.
  However, the security is still better than with a qemu-dm running as
  an unrestricted dom0 process.  Therefore users with these
  configurations should not switch to an unrestricted dom0 qemu-dm.
  Finally, in a radically disaggregated system: where the HVM service
  domain software (probably, the device model domain image) is not
  always supplied by the host administrator, a malicious service domain
  administrator can exercise this vulnerability.
  MITIGATION
  ==========
  Running only PV guests will avoid this vulnerability.
  In a radically disaggregated system, restricting HVM service domains
  to software images approved by the host administrator will avoid the
  vulnerability.
  =================================================================
  Permitting arbitrary type changes here has the potential of creating
  present P2M (and hence EPT/NPT/IOMMU) entries pointing to an invalid
  MFN (INVALID_MFN truncated to the respective hardware structure field's
  width). This would become a problem the latest when something real sat
  at the end of the physical address space; I'm suspecting though that
  other things might break with such bogus entries.
  Along with that drop a bogus (and otherwise becoming stale) log
  message.
  Afaict the similar operation in p2m_set_mem_access() is safe.
  This is XSA-92.
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Reviewed-by: Tim Deegan <tim@xen.org>
  commit: 83bb5eb4d340acebf27b34108fb1dae062146a68
  Signed-off-by: Boris Ostrovsky <boris.ostrovsky@oracle.com> [bug 18692196]  

* Tue Apr 15 2014 Firas Azar <firas.azar@oracle.com> - 4.3.0-50 
- Signed-off by: Adnan G Misherfi <adnan.misherfi@oracle.com>
  Signed-off by: Zhigang Wang <zhigang.x.wang@oracle.com> [bug 18560587]  

* Fri Apr 11 2014 Jingjie Jiang <jingjie.jiang@oracle.com> - 4.3.0-49 
- Check in the following patch for Konrad:
  From Message-ID: <1332267691-13179-1-git-send-email-david.vrabel@citrix.com>
  If a maximum reservation for dom0 is not explictly given (i.e., no
  dom0_mem=max:MMM command line option), then set the maximum
  reservation to the initial number of pages.  This is what most people
  seem to expect when they specify dom0_mem=512M (i.e., exactly 512 MB
  and no more).
  This change means that with Linux 3.0.5 and later kernels,
  dom0_mem=512M has the same result as older, 'classic Xen' kernels. The
  older kernels used the initial number of pages to set the maximum
  number of pages and did not query the hypervisor for the maximum
  reservation.
  It is still possible to have a larger reservation by explicitly
  specifying dom0_mem=max:MMM.
  Signed-off-by: David Vrabel <david.vrabel@citrix.com>
  Signed-off-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com>
  NOTE: This behaviour should also be implemented in the Linux kernel. [bug 13860516] [bug 18552768]  

* Thu Apr 10 2014 Adnan Misherfi <adnan.misherfi@oracle.com> - 4.3.0-48 
- Check in the following patch for Konrad:
  From: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com>
  When we migrate an HVM guest, by default our shared_info can
  only hold up to 32 CPUs. As such the hypercall
  VCPUOP_register_vcpu_info was introduced which allowed us to
  setup per-page areas for VCPUs. This means we can boot PVHVM
  guest with more than 32 VCPUs. During migration the per-cpu
  structure is allocated fresh by the hypervisor (vcpu_info_mfn
  is set to INVALID_MFN) so that the newly migrated guest
  can do make the VCPUOP_register_vcpu_info hypercall.
  Unfortunatly we end up triggering this condition:
  /* Run this command on yourself or on other offline VCPUS. */
  if ( (v != current) && !test_bit(_VPF_down, &v->pause_flags) )
  which means we are unable to setup the per-cpu VCPU structures
  for running vCPUS. The Linux PV code paths make this work by
  iterating over every vCPU with:
  1) is target CPU up (VCPUOP_is_up hypercall?)
  2) if yes, then VCPUOP_down to pause it.
  3) VCPUOP_register_vcpu_info
  4) if it was down, then VCPUOP_up to bring it back up
  But since VCPUOP_down, VCPUOP_is_up, and VCPUOP_up are
  not allowed on HVM guests we can't do this. This patch
  enables this.
  Signed-off-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com> [bug 18552539]  

* Fri Apr 04 2014 Boris Ostrovsky <boris.ostrovsky@oracle.com> - 4.3.0-47 
- x86: enforce preemption in HVM_set_mem_access / p2m_set_mem_access()
  Xen Security Advisory CVE-2014-2599 / XSA-89
  version 3
  HVMOP_set_mem_access is not preemptible
  UPDATES IN VERSION 3
  ====================
  This issue has been assigned CVE-2014-2599.
  ISSUE DESCRIPTION
  =================
  Processing of the HVMOP_set_mem_access HVM control operations does not
  check the size of its input and can tie up a physical CPU for extended
  periods of time.
  IMPACT
  ======
  In a configuration where device models run with limited privilege (for
  example, stubdom device models), a guest attacker who successfully
  finds and exploits an unfixed security flaw in qemu-dm could leverage
  the other flaw into a Denial of Service affecting the whole host.
  In the more general case, in more abstract terms: a malicious
  administrator of a domain privileged with regard to an HVM guest can
  cause Xen to become unresponsive leading to a Denial of Service.
  VULNERABLE SYSTEMS
  ==================
  All Xen versions from 4.1 onwards are vulnerable. In 4.2 only 64-bit
  versions of the hypervisor are vulnerable (HVMOP_set_mem_access is not
  available in 32-bit hypervisors).
  The vulnerability is only exposed to service domains for HVM guests
  which have privilege over the guest.  In a usual configuration that
  means only device model emulators (qemu-dm).
  In the case of HVM guests whose device model is running in an
  unrestricted dom0 process, qemu-dm already has the ability to cause
  problems for the whole system.  So in that case the vulnerability is
  not applicable.
  The situation is more subtle for an HVM guest with a stub qemu-dm.
  That is, where the device model runs in a separate domain (in the case
  of xl, as requested by "device_model_stubdomain_override=1" in the xl
  domain configuration file).  The same applies with a qemu-dm in a dom0
  process subjected to some kind kernel-based process privilege
  limitation (eg the chroot technique as found in some versions of
  XCP/XenServer).
  In those latter situations this issue means that the extra isolation
  does not provide as good a defence (against denial of service) as
  intended.  That is the essence of this vulnerability.
  However, the security is still better than with a qemu-dm running as
  an unrestricted dom0 process.  Therefore users with these
  configurations should not switch to an unrestricted dom0 qemu-dm.
  Finally, in a radically disaggregated system: where the HVM service
  domain software (probably, the device model domain image) is not
  always supplied by the host administrator, a malicious service domain
  administrator can excercise this vulnerability.
  MITIGATION
  ==========
  Running only PV guests will avoid this vulnerability.
  In a radically disaggregated system, restricting HVM service domains
  to software images approved by the host administrator will avoid the
  vulnerability.
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Reviewed-by: Tim Deegan <tim@xen.org>
  commit: 0fe53c4f279e1a8ef913e71ed000236d21ce96de
  Signed-off-by: Boris Ostrovsky <boris.ostrovsky@oracle.com> [bug 18521502]  

* Fri Apr 04 2014 Adnan Misherfi <adnan.misherfi@oracle.com> - 4.3.0-46 
- The flowing patch was missed when we upgraded OVM xen to 4.3:
  From 5eda9dfe0a2e11d9c91717f83ddbb2f52e7535e7 Mon Sep 17 00:00:00 2001
  From: Zhenzhong Duan <zhenzhong.duan@oracle.com>
  Date: Fri, 4 Apr 2014 15:36:36 -0400
  Subject: [PATCH] qemu-xen-trad: free all the pirqs for msi/msix when driver
  unloads
  Pirqs are not freed when driver unloads, then new pirqs are allocated when
  driver reloads. This could exhaust pirqs if do it in a loop.
  This patch fixes the bug by freeing pirqs when ENABLE bit is cleared in
  msi/msix control reg.
  There is also other way of fixing it such as reuse pirqs between driver reload,
  but this way is better.
  Xen-devel: http://marc.info/?l=xen-devel&m=136800120304275&w=2
  Signed-off-by: Zhenzhong Duan <zhenzhong.duan@oracle.com>
  Signed-off-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.c [bug 16910937]  

* Thu Apr 03 2014 Adnan Misherfi <adnan.misherfi@oracle.com> - 4.3.0-45 
- check in upstream dd03048 patch to add support for OL7 VM [bug 18487695]  

* Thu Mar 27 2014 Chuang Cao <chuang.cao@oracle.com> - 4.3.0-44 
- Just release running lock after a domain is gone.
  Signed-off-by: Chuang Cao <chuang.cao@oracle.com>
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Acked-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com>
  Acked-by: Adnan Misherfi <adnan.misherfi@oracle.com>
  Acked-by: Julie Trask <julie.trask@oracle.com> [bug 17936558]  

* Mon Mar 10 2014 Annie Li <annie.li@oracle.com> - 4.3.0-43 
- Backport xen patch "reset TSC to 0 after domain resume from S3" [bug 18010443]  

* Fri Feb 28 2014 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.3.0-42 
- Release domain running lock correctly
  When the domain dies very early by:
  VmError: HVM guest support is unavailable: is VT/AMD-V supported by your CPU and enabled in your BIOS?
  We don't release release the domain running lock correctly.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com> [bug 18328751]  

* Mon Feb 17 2014 Boris Ostrovsky <boris.ostrovsky@oracle.com> - 4.3.0-41 
- x86/pci: Store VF's memory space displacement in a 64-bit value
  VF's memory space offset can be greater than 4GB and therefore needs
  to be stored in a 64-bit variable.
  commit: 001bdcee7bc19be3e047d227b4d940c04972eb02
  Acked-by: Adnan Misherfi <adnan.misherfi@oracle.com>
  Signed-off-by: Boris Ostrovsky <boris.ostrovsky@oracle.com> [bug 18262495]  

* Fri Feb 14 2014 Boris Ostrovsky <boris.ostrovsky@oracle.com> - 4.3.0-40 
- libxc: Fix out-of-memory error handling in xc_cpupool_getinfo()
  Xen Security Advisory CVE-2014-1950 / XSA-88
  version 3
  use-after-free in xc_cpupool_getinfo() under memory pressure
  UPDATES IN VERSION 3
  ====================
  CVE assigned.
  ISSUE DESCRIPTION
  =================
  If xc_cpumap_alloc() fails then xc_cpupool_getinfo() will free and incorrectly
  return the then-free pointer to the result structure.
  IMPACT
  ======
  An attacker may be able to cause a multi-threaded toolstack using this
  function to race against itself leading to heap corruption and a
  potential DoS.
  Depending on the malloc implementation, privilege escalation cannot be
  ruled out.
  VULNERABLE SYSTEMS
  ==================
  The flaw is present in Xen 4.1 onwards.  Only multithreaded toolstacks
  are vulnerable.  Only systems where management functions (such as
  domain creation) are exposed to untrusted users are vulnerable.
  xl is not multithreaded, so is not vulnerable.  However, multithreaded
  toolstacks using libxl as a library are vulnerable.  xend is
  vulnerable.
  MITIGATION
  ==========
  Not allowing untrusted users access to toolstack functionality will
  avoid this issue.
  Signed-off-by: Andrew Cooper <andrew.cooper3@citrix.com>
  Reviewed-by: Jan Beulich <jbeulich@suse.com>
  commit: d883c179a74111a6804baf8cb8224235242a88fc
  Signed-off-by: Boris Ostrovsky <boris.ostrovsky@oracle.com> [bug 18252940]  

* Fri Feb 14 2014 Boris Ostrovsky <boris.ostrovsky@oracle.com> - 4.3.0-39 
- x86: PHYSDEVOP_{prepare,release}_msix are privileged
  Xen Security Advisory CVE-2014-1666 / XSA-87
  version 2
  PHYSDEVOP_{prepare,release}_msix exposed to unprivileged guests
  UPDATES IN VERSION 2
  ====================
  CVE assigned.
  ISSUE DESCRIPTION
  =================
  The PHYSDEVOP_{prepare,release}_msix operations are supposed to be available
  to privileged guests (domain 0 in non-disaggregated setups) only, but the
  necessary privilege check was missing.
  IMPACT
  ======
  Malicious or misbehaving unprivileged guests can cause the host or other
  guests to malfunction. This can result in host-wide denial of service.
  Privilege escalation, while seeming to be unlikely, cannot be excluded.
  VULNERABLE SYSTEMS
  ==================
  Xen 4.1.5 and 4.1.6.1 as well as 4.2.2 and later are vulnerable.
  Xen 4.2.1 and 4.2.0 as well as 4.1.4 and earlier are not vulnerable.
  Only PV guests can take advantage of this vulnerability.
  MITIGATION
  ==========
  Running only HVM guests will avoid this issue.
  There is no mitigation available for PV guests.
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Reviewed-by: Andrew Cooper <andrew.cooper3@citrix.com>
  commit: 9c7e789a1b60b6114e0b1ef16dff95f03f532fb5
  Signed-off-by: Boris Ostrovsky <boris.ostrovsky@oracle.com> [bug 18252940]  

* Fri Feb 14 2014 Boris Ostrovsky <boris.ostrovsky@oracle.com> - 4.3.0-38 
- libvchan: Fix handling of invalid ring buffer indices
  Xen Security Advisory CVE-2014-1896 / XSA-86
  version 3
  libvchan failure handling malicious ring indexes
  UPDATES IN VERSION 3
  ====================
  CVE assigned.
  ISSUE DESCRIPTION
  =================
  libvchan (a library for inter-domain communication) does not correctly
  handle unusual or malicious contents in the xenstore ring.  A
  malicious guest can exploit this to cause a libvchan-using facility to
  read or write past the end of the ring.
  IMPACT
  ======
  libvchan-using facilities are vulnerable to denial of service and
  perhaps privilege escalation.
  There are no such services provided in the upstream Xen Project
  codebase.
  VULNERABLE SYSTEMS
  ==================
  All versions of libvchan are vulnerable.  Only installations which use
  libvchan for communication involving untrusted domains are vulnerable.
  libvirt, xapi, xend, libxl and xl do not use libvchan.  If your
  installation contains other Xen-related software components it is
  possible that they use libvchan and might be vulnerable.
  Xen versions 4.1 and earlier do not contain libvchan.
  MITIGATION
  ==========
  Disabling libvchan-based facilities could be used to mitigate the
  vulnerability.
  ===================================================================
  The remote (hostile) process can set ring buffer indices to any value
  at any time. If that happens, it is possible to get "buffer space"
  (either for writing data, or ready for reading) negative or greater
  than buffer size.  This will end up with buffer overflow in the second
  memcpy inside of do_send/do_recv.
  Fix this by introducing new available bytes accessor functions
  raw_get_data_ready and raw_get_buffer_space which are robust against
  mad ring states, and only return sanitised values.
  Proof sketch of correctness:
  Now {rd,wr}_{cons,prod} are only ever used in the raw available bytes
  functions, and in do_send and do_recv.
  The raw available bytes functions do unsigned arithmetic on the
  returned values.  If the result is "negative" or too big it will be
  >ring_size (since we used unsigned arithmetic).  Otherwise the result
  is a positive in-range value representing a reasonable ring state, in
  which case we can safely convert it to int (as the rest of the code
  expects).
  do_send and do_recv immediately mask the ring index value with the
  ring size.  The result is always going to be plausible.  If the ring
  state has become mad, the worst case is that our behaviour is
  inconsistent with the peer's ring pointer.  I.e. we read or write to
  arguably-incorrect parts of the ring - but always parts of the ring.
  And of course if a peer misoperates the ring they can achieve this
  effect anyway.
  So the security problem is fixed.
  This is XSA-86.
  (The patch is essentially Ian Jackson's work, although parts of the
  commit message are by Marek.)
  Signed-off-by: Marek Marczykowski-G?195?179recki <marmarek@invisiblethingslab.com>
  Signed-off-by: Ian Jackson <ian.jackson@eu.citrix.com>
  commit: 2efcb0193bf3916c8ce34882e845f5ceb1e511f7
  Signed-off-by: Boris Ostrovsky <boris.ostrovsky@oracle.com> [bug 18252940]  

* Fri Feb 14 2014 Boris Ostrovsky <boris.ostrovsky@oracle.com> - 4.3.0-37 
- xsm/flask: correct off-by-one in flask_security_avc_cachestats cpu id check
  Xen Security Advisory CVE-2014-1895 / XSA-85
  version 3
  Off-by-one error in FLASK_AVC_CACHESTAT hypercall
  UPDATES IN VERSION 3
  ====================
  CVE assigned.
  ISSUE DESCRIPTION
  =================
  The FLASK_AVC_CACHESTAT hypercall, which provides access to per-cpu
  statistics on the Flask security policy, incorrectly validates the
  CPU for which statistics are being requested.
  IMPACT
  ======
  An attacker can cause the hypervisor to read past the end of an
  array. This may result in either a host crash, leading to a denial of
  service, or access to a small and static region of hypervisor memory,
  leading to an information leak.
  VULNERABLE SYSTEMS
  ==================
  Xen version 4.2 and later are vulnerable to this issue when built with
  XSM/Flask support. XSM support is disabled by default and is enabled
  by building with XSM_ENABLE=y.
  Only systems with the maximum supported number of physical CPUs are
  vulnerable. Systems with a greater number of physical CPUs will only
  make use of the maximum supported number and are therefore vulnerable.
  By default the following maximums apply:
  * x86_32: 128 (only until Xen 4.2.x)
  * x86_64: 256
  These defaults can be overridden at build time via max_phys_cpus=N.
  The vulnerable hypercall is exposed to all domains.
  MITIGATION
  ==========
  Rebuilding Xen with more supported physical CPUs can avoid the
  vulnerability; provided that the supported number is strictly greater
  than the actual number of CPUs on any host on which the hypervisor is
  to run.
  If XSM is compiled in, but not actually in use, compiling it out (with
  XSM_ENABLE=n) will avoid the vulnerability.
  Signed-off-by: Matthew Daley <mattd@bugfuzz.com>
  Reviewed-by: Jan Beulich <jbeulich@suse.com>
  Reviewed-by: Ian Campbell <ian.campbell@citrix.com>
  commit: 2e1cba2da4631c5cd7218a8f30d521dce0f41370
  Signed-off-by: Boris Ostrovsky <boris.ostrovsky@oracle.com> [bug 18252940]  

* Fri Feb 14 2014 Boris Ostrovsky <boris.ostrovsky@oracle.com> - 4.3.0-36 
- flask: fix reading strings from guest memory
  Xen Security Advisory CVE-2014-1891,CVE-2014-1892,CVE-2014-1893,CVE-2014-1894 / XSA-84
  version 3
  integer overflow in several XSM/Flask hypercalls
  UPDATES IN VERSION 3
  ====================
  CVE numbers have been assigned.
  ISSUE DESCRIPTION
  =================
  The FLASK_{GET,SET}BOOL, FLASK_USER and FLASK_CONTEXT_TO_SID
  suboperations of the flask hypercall are vulnerable to an integer
  overflow on the input size. The hypercalls attempt to allocate a
  buffer which is 1 larger than this size and is therefore vulnerable to
  integer overflow and an attempt to allocate then access a zero byte
  buffer.  (CVE-2014-1891)
  Xen 3.3 through 4.1, while not affected by the above overflow, have a
  different overflow issue on FLASK_{GET,SET}BOOL (CVE-2014-1893) and
  expose unreasonably large memory allocation to aribitrary guests
  (CVE-2014-1892).
  Xen 3.2 (and presumably earlier) exhibit both problems with the
  overflow issue being present for more than just the suboperations
  listed above.  (CVE-2014-1894 for the subops not covered above.)
  The FLASK_GETBOOL op is available to all domains.
  The FLASK_SETBOOL op is only available to domains which are granted
  access via the Flask policy.  However the permissions check is
  performed only after running the vulnerable code and the vulnerability
  via this subop is exposed to all domains.
  The FLASK_USER and FLASK_CONTEXT_TO_SID ops are only available to
  domains which are granted access via the Flask policy.
  IMPACT
  ======
  Attempting to access the result of a zero byte allocation results in
  a processor fault leading to a denial of service.
  VULNERABLE SYSTEMS
  ==================
  All Xen versions back to at least 3.2 are vulnerable to this issue when
  built with XSM/Flask support. XSM support is disabled by default and is
  enabled by building with XSM_ENABLE=y.
  We have not checked earlier versions of Xen, but it is likely that
  they are vulnerable to this or related vulnerabilities.
  All Xen versions built with XSM_ENABLE=y are vulnerable.
  MITIGATION
  ==========
  There is no useful mitigation available in installations where XSM
  support is actually in use.
  In other systems, compiling it out (with XSM_ENABLE=n) will avoid the
  vulnerability.
  Reported-by: Matthew Daley <mattd@bugfuzz.com>
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Acked-by: Daniel De Graaf <dgdegra@tycho.nsa.gov>
  commit: 6c79e0ab9ac6042e60434c02e1d99b0cf0cc3470
  Signed-off-by: Boris Ostrovsky <boris.ostrovsky@oracle.com> [bug 18252940]  

* Fri Feb 14 2014 Boris Ostrovsky <boris.ostrovsky@oracle.com> - 4.3.0-35 
- x86/irq: avoid use-after-free on error path in pirq_guest_bind()
  Xen Security Advisory CVE-2014-1642 / XSA-83
  version 3
  Out-of-memory condition yielding memory corruption during IRQ setup
  UPDATES IN VERSION 3
  ====================
  CVE assigned.
  ISSUE DESCRIPTION
  =================
  When setting up the IRQ for a passed through physical device, a flaw
  in the error handling could result in a memory allocation being used
  after it is freed, and then freed a second time.  This would typically
  result in memory corruption.
  IMPACT
  ======
  Malicious guest administrators can trigger a use-after-free error, resulting
  in hypervisor memory corruption.  The effects of memory corruption could be
  anything, including a host-wide denial of service, or privilege escalation.
  VULNERABLE SYSTEMS
  ==================
  Xen 4.2.x and later are vulnerable.
  Xen 4.1.x and earlier are not vulnerable.
  Only systems making use of device passthrough are vulnerable.
  Only systems with a 64-bit hypervisor configured to support more than 128
  CPUs or with a 32-bit hypervisor configured to support more than 64 CPUs are
  vulnerable.
  MITIGATION
  ==========
  This issue can be avoided by not assigning PCI devices to untrusted guests on
  systems supporting Intel VT-d or AMD Vi.
  Signed-off-by: Andrew Cooper <andrew.cooper3@citrix.com>
  Reviewed-by: Jan Beulich <jbeulich@suse.com>
  commit: 650fc2f76d0a156e23703683d0c18fa262ecea36
  Signed-off-by: Boris Ostrovsky <boris.ostrovsky@oracle.com> [bug 18252940]  

* Wed Jan 29 2014 Adnan Misherfi <adnan.misherfi@oracle.com> - 4.3.0-34 
- Test if openvswitch kernel module is loaded to determine where to attach the VIF (bridge or openvswitch) [bug 17885201]  

* Wed Jan 22 2014 Firas Azar <firas.azar@oracle.com> - 4.3.0-33 
- Signed-off by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off by: Adnan G Misherfi <adnan.misherfi@oracle.com> [bug 18048615]  

* Fri Jan 17 2014 Daniel Kiper <daniel.kiper@oracle.com> - 4.3.0-32
  Add following upstream commits:
    - 2cebe22e6924439535cbf4a9f82a7d9d30c8f9c7
      (libxenctrl: Fix xc_interface_close() crash if it gets NULL as an argument),
    - dc37e0bfffc673f4bdce1d69ad86098bfb0ab531
      (x86: fix early boot command line parsing),
    - 7113a45451a9f656deeff070e47672043ed83664
      (kexec/x86: do not map crash kernel area).

* Mon Jan 13 2014 Firas Azar <firas.azar@oracle.com> - 4.3.0-31 
- Signed-off by: Adnan G Misherfi <adnan.misherfi@oracle.com>
  Signed-off by: Zhigang Wang <zhigang.x.wang@oracle.com> [bug 18048615]  

* Wed Jan 08 2014 Boris Ostrovsky <boris.ostrovsky@oracle.com> - 4.3.0-30 
- VMX patches for XSA-60
  Xen Security Advisory CVE-2013-2212 / XSA-60
  version 5
  Excessive time to disable caching with HVM guests with PCI passthrough
  UPDATES IN VERSION 5
  ====================
  Corrected credit.
  ISSUE DESCRIPTION
  =================
  HVM guests are able to manipulate their physical address space such that
  processing a subsequent request by that guest to disable caches takes an
  extended amount of time changing the cachability of the memory pages assigned
  to this guest. This applies only when the guest has been granted access to
  some memory mapped I/O region (typically by way of assigning a passthrough
  PCI device).
  This can cause the CPU which processes the request to become unavailable,
  possibly causing the hypervisor or a guest kernel (including the domain 0 one)
  to halt itself ("panic").
  For reference, as long as no patch implementing an approved alternative
  solution is available (there's only a draft violating certain requirements
  set by Intel's documentation), the problematic code is the function
  vmx_set_uc_mode() (in that it calls ept_change_entry_emt_with_range() with
  the full guest GFN range, which the guest has control over, but which also
  would be a problem with sufficiently large but not malicious guests).
  IMPACT
  ======
  A malicious domain, given access to a device with memory mapped I/O
  regions, can cause the host to become unresponsive for a period of
  time, potentially leading to a DoS affecting the whole system.
  VULNERABLE SYSTEMS
  ==================
  Xen version 3.3 onwards is vulnerable.
  Only systems using the Intel variant of Hardware Assisted Paging (aka EPT) are
  vulnerable.
  MITIGATION
  ==========
  This issue can be avoided by not assigning PCI devices to untrusted guests, or
  by running HVM guests with shadow mode paging (through adding "hap=0" to the
  domain configuration file).
  This XSA is addressed by 3 patches:
  1. VMX: disable EPT when !cpu_has_vmx_pat
  Recently Oracle developers found a Xen security issue as DOS affecting,
  named as XSA-60. Please refer http://xenbits.xen.org/xsa/advisory-60.html
  Basically it involves how to handle guest cr0.cd setting, which under
  some environment it consumes much time resulting in DOS-like behavior.
  This is a preparing patch for fixing XSA-60. Later patch will fix XSA-60
  via PAT under Intel EPT case, which depends on cpu_has_vmx_pat.
  Signed-off-by: Liu Jinsong <jinsong.liu@intel.com>
  Reviewed-by: Jan Beulich <jbeulich@suse.com>
  Reviewed-by: Andrew Cooper <andrew.cooper3@citrix.com>
  Reviewed-by: Tim Deegan <tim@xen.org>
  Acked-by: Jun Nakajima <jun.nakajima@intel.com>
  commit: 72380ecbcd9f870db1c60e698c9df71bdea6d819
  2. VMX: remove the problematic set_uc_mode logic
  XSA-60 security hole comes from the problematic vmx_set_uc_mode.
  This patch remove vmx_set_uc_mode logic, which will be replaced by
  PAT approach at later patch.
  Signed-off-by: Liu Jinsong <jinsong.liu@intel.com>
  Reviewed-by: Jan Beulich <jbeulich@suse.com>
  Reviewed-by: Andrew Cooper <andrew.cooper3@citrix.com>
  Reviewed-by: Tim Deegan <tim@xen.org>
  Acked-by: Jun Nakajima <jun.nakajima@intel.com>
  commit: e81d0ac25464825b3828cff5dc9e8285612992c4
  3. VMX: fix cr0.cd handling
  This patch solves XSA-60 security hole:
  1. For guest w/o VT-d, and for guest with VT-d but snooped, Xen need
  do nothing, since hardware snoop mechanism has ensured cache coherency.
  2. For guest with VT-d but non-snooped, cache coherency can not be
  guaranteed by h/w snoop, therefore it need emulate UC type to guest:
  2.1). if it works w/ Intel EPT, set guest IA32_PAT fields as UC so that
  guest memory type are all UC.
  2.2). if it works w/ shadow, drop all shadows so that any new ones would
  be created on demand w/ UC.
  This patch also fix a bug of shadow cr0.cd setting. Current shadow has a
  small window between cache flush and TLB invalidation, resulting in possilbe
  cache pollution. This patch pause vcpus so that no vcpus context involved
  into the window.
  Signed-off-by: Liu Jinsong <jinsong.liu@intel.com>
  Reviewed-by: Jan Beulich <jbeulich@suse.com>
  Reviewed-by: Tim Deegan <tim@xen.org>
  Reviewed-by: Andrew Cooper <andrew.cooper3@citrix.com>
  Acked-by: Jun Nakajima <jun.nakajima@intel.com>
  Acked-by: Keir Fraser <keir@xen.org>
  commit: 064275dcfb6002dc4327ba94b6bd758806735538
  Signed-off-by: Boris Ostrovsky <boris.ostrovsky@oracle.com> 

* Wed Jan 08 2014 Boris Ostrovsky <boris.ostrovsky@oracle.com> - 4.3.0-29 
- x86/AMD: work around erratum 793
  Xen Security Advisory CVE-2013-6885 / XSA-82
  version 3
  Guest triggerable AMD CPU erratum may cause host hang
  UPDATES IN VERSION 3
  ====================
  Early public release.
  This issue was predisclosed under embargo by the Xen Project Security
  team, on the 27th of November.  We treated the issue as not publicly
  known because it was not evident from the public sources that this
  erratum constitutes a vulnerability (particularly, that it was a
  vulnerability in relation to some Xen configurations).
  Since then, the fact that this CPU erratum is likely to constitute a
  security problem has been publicly disclosed, on the oss-security
  mailing list.
  Under the circumstances, and in accordance with the Xen Project
  security vulnerability policy, it has been decided that it is no
  longer appropriate to retain the embargo, as the key facts are now in
  the open.
  ISSUE DESCRIPTION
  =================
  AMD CPU erratum 793 "Specific Combination of Writes to Write Combined
  Memory Types and Locked Instructions May Cause Core Hang" describes a
  situation under which a CPU core may hang.
  IMPACT
  ======
  A malicious guest administrator can mount a denial of service attack
  affecting the whole system.
  VULNERABLE SYSTEMS
  ==================
  The vulnerability is applicable only to family 16h model 00h-0fh AMD
  CPUs.
  Such CPUs running Xen versions 3.3 onwards are vulnerable.  We have
  not checked earlier versions of Xen.
  HVM guests can always exploit the vulnerability if it is present.
  PV guests can exploit the vulnerability only if they have been granted
  access to physical device(s).
  Non-AMD CPUs are not vulnerable.
  CREDITS
  =======
  This issue's security impact was discovered by Jan Beulich.
  MITIGATION
  ==========
  This issue can be avoided by neither running HVM guests, nor assigning
  PCI devices to PV guests.
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Acked-by: Suravee Suthikulpanit <suravee.suthikulpanit@amd.com>
  commit in xen-unstable: 98162f256ee33994a9881a720419dda9ad4c03a8
  Signed-off-by: Boris Ostrovsky <boris.ostrovsky@oracle.com> 

* Wed Jan 08 2014 Boris Ostrovsky <boris.ostrovsky@oracle.com> - 4.3.0-28 
- IOMMU: clear "don't flush" override on error paths
  Xen Security Advisory CVE-2013-6400 / XSA-80
  version 3
  IOMMU TLB flushing may be inadvertently suppressed
  UPDATES IN VERSION 3
  ====================
  Public release.
  Corrected explanatory text to refer to the correct patch filename.
  ISSUE DESCRIPTION
  =================
  An internal flag is used to temporarily suppress IOMMU TLB flushes, in
  order to consolidate multiple single page flushes into one wider
  flush.  This flag is not cleared again, on certain error paths.  This
  can result in TLB flushes not happening when they are needed.
  Retaining stale TLB entries could allow guests access to memory that
  ought to have been revoked, or grant greater access than intended.
  IMPACT
  ======
  Malicious guest administrators might be able to cause host-wide denial of
  service, or escalate their privilege to that of the host.
  VULNERABLE SYSTEMS
  ==================
  Only VMs which have been assigned PCI devices can exploit the bug.
  Only systems using Intel VT-d are vulnerable, since the bug is in the
  VT-d specific code in Xen.
  Xen 4.2.x and later are vulnerable.
  Xen 4.1.x and earlier are not vulnerable.
  MITIGATION
  ==========
  This issue can be avoided by not assigning PCI devices to untrusted guests on
  systems supporting Intel VT-d.
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Acked-by: Ian Campbell <ian.campbell@citrix.com>
  commit: 8940a13d6de1295cfdc4a189e0a5610849a9ef59
  Signed-off-by: Boris Ostrovsky <boris.ostrovsky@oracle.com> 

* Wed Jan 08 2014 Boris Ostrovsky <boris.ostrovsky@oracle.com> - 4.3.0-27 
- VT-d: fix TLB flushing in dma_pte_clear_one()
  Xen Security Advisory CVE-2013-6375 / XSA-78
  version 2
  Insufficient TLB flushing in VT-d (iommu) code
  UPDATES IN VERSION 2
  ====================
  This issue has been assigned CVE-2013-6375.
  ISSUE DESCRIPTION
  =================
  An inverted boolean parameter resulted in TLB flushes not happening
  upon clearing of a present translation table entry.  Retaining stale
  TLB entries could allow guests access to memory that ought to have
  been revoked, or grant greater access than intended.
  IMPACT
  ======
  Malicious guest administrators might be able to cause host-wide denial
  of service, or escalate their privilege to that of the host.
  VULNERABLE SYSTEMS
  ==================
  Xen 4.2.x and later are vulnerable.
  Xen 4.1.x and earlier are not vulnerable.
  Only systems using Intel VT-d for PCI passthrough are vulnerable.
  MITIGATION
  ==========
  This issue can be avoided by not assigning PCI devices to untrusted guests on
  systems supporting Intel VT-d.
  Suggested-by: Cheng Yueqiang <yqcheng.2008@phdis.smu.edu.sg>
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Reviewed-by: Andrew Cooper <andrew.cooper3@citrix.com>
  Acked-by: Keir Fraser <keir@xen.org>
  commit: 7482b89e67e4681d515224b6fc8c00f017979d6f
  Signed-off-by: Boris Ostrovsky <boris.ostrovsky@oracle.com> 

* Wed Jan 08 2014 Boris Ostrovsky <boris.ostrovsky@oracle.com> - 4.3.0-26 
- x86/HVM: only allow ring 0 guest code to make hypercalls
  Xen Security Advisory CVE-2013-4554 / XSA-76
  version 3
  Hypercalls exposed to privilege rings 1 and 2 of HVM guests
  UPDATES IN VERSION 3
  ====================
  Public release.
  ISSUE DESCRIPTION
  =================
  The privilege check applied to hypercall attempts by a HVM guest only refused
  access from ring 3; rings 1 and 2 were allowed through.
  IMPACT
  ======
  Code running in the intermediate privilege rings of HVM guest OSes may be able
  to elevate its privileges inside the guest by careful hypercall use.
  VULNERABLE SYSTEMS
  ==================
  Xen 3.0.3 and later are vulnerable.
  Xen 3.0.2 and earlier are not vulnerable.
  MITIGATION
  ==========
  Running only PV guests, or running HVM guests known to not make use of
  protection rings 1 and 2 will avoid this issue. As far as we are aware no
  mainstream OS (Linux, Windows, BSD) make use of these rings.
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Acked-by: Ian Campbell <ian.campbell@citrix.com>
  commit: 82b79aceed17a3ca45e2b87b4c95965ba19f803e
  Signed-off-by: Boris Ostrovsky <boris.ostrovsky@oracle.com> 

* Wed Jan 08 2014 Boris Ostrovsky <boris.ostrovsky@oracle.com> - 4.3.0-25 
- nested VMX: VMLANUCH/VMRESUME emulation must check permission first thing
  Xen Security Advisory CVE-2013-4551 / XSA-75
  version 2
  Host crash due to guest VMX instruction execution
  UPDATES IN VERSION 2
  ====================
  This issue has been assigned CVE-2013-4551.
  ISSUE DESCRIPTION
  =================
  Permission checks on the emulation paths (intended for guests using
  nested virtualization) for VMLAUNCH and VMRESUME were deferred too
  much.  The hypervisor would try to use internal state which is not set
  up unless nested virtualization is actually enabled for a guest.
  IMPACT
  ======
  A malicious or misbehaved HVM guest, including malicious or misbehaved user
  mode code run in the guest, might be able to crash the host.
  VULNERABLE SYSTEMS
  ==================
  Xen 4.2.x and later are vulnerable.
  Xen 4.1.x and earlier are not vulnerable.
  Only HVM guests run on VMX capable (e.g. Intel) hardware can take
  advantage of this vulnerability.
  MITIGATION
  ==========
  Running only PV guests, or running HVM guests on SVM capable
  (e.g. AMD) hardware will avoid this issue.
  Enabling nested virtualization for a HVM guest running on VMX capable
  hardware would also allow avoiding the issue.  However this
  functionality is still considered experimental, and is not covered by
  security support from the Xen Project security team.  This approach is
  therefore not recommended for use in production.
  Reported-and-tested-by: Jeff Zimmerman <Jeff_Zimmerman@McAfee.com>
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Reviewed-and-tested-by: Andrew Cooper <andrew.cooper3@citrix.com>
  Acked-by: Ian Campbell <ian.campbell@citrix.com>
  commit: d86a985a273662f3275ee60585d7507d457802a1
  Signed-off-by: Boris Ostrovsky <boris.ostrovsky@oracle.com> [bug 18049441]  

* Wed Jan 08 2014 Boris Ostrovsky <boris.ostrovsky@oracle.com> - 4.3.0-24 
- x86: restrict XEN_DOMCTL_getmemlist
  Xen Security Advisory CVE-2013-4553 / XSA-74
  version 3
  Lock order reversal between page_alloc_lock and mm_rwlock
  UPDATES IN VERSION 3
  ====================
  Public release.
  ISSUE DESCRIPTION
  =================
  The locks page_alloc_lock and mm_rwlock are not always taken in
  the same order.  This raises the possibility of deadlock.
  The incorrect order occurs only in the implementation of the
  deprecated domctl hypercall XEN_DOMCTL_getmemlist.
  IMPACT
  ======
  A malicious guest administrator may be able to deny service to the
  entire host.
  VULNERABLE SYSTEMS
  ==================
  Xen 3.4.x and later are vulnerable.
  Xen 3.3.x and earlier are not vulnerable.
  Only systems where a privileged domain frequently or predictably uses
  XEN_DOMCTL_getmemlist are vulnerable.  (Its use by manually invoked
  debugging and stress testing tools is not a security problem.)
  We are not aware of any toolstack software which has relevant (and
  hence vulnerable) uses of this hypercall.  xend, libxl, xapi and
  libvirt are known not to do so.
  We are therefore not aware of any deployed Xen-based systems which are
  vulnerable.  We are issuing this advisory primarily for the benefit of
  any Xen-derived systems using unusual toolstack software.
  MITIGATION
  ==========
  If you are using a toolstack (or other software) which uses
  XEN_DOMCTL_getmemlist, disabling the relevant feature or functions may
  be possible, and would avoid the vulnerability.
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Reviewed-by: Andrew Cooper <andrew.cooper3@citrix.com>
  Reviewed-by: Tim Deegan <tim@xen.org>
  commit: 9229cff72fd9490c103ebf644e432bb6c4fb69c5
  Signed-off-by: Boris Ostrovsky <boris.ostrovsky@oracle.com> [bug 18049441]  

* Wed Jan 08 2014 Boris Ostrovsky <boris.ostrovsky@oracle.com> - 4.3.0-23 
- gnttab: correct locking order reversal
  Xen Security Advisory CVE-2013-4494 / XSA-73
  version 3
  Lock order reversal between page allocation and grant table locks
  UPDATES IN VERSION 3
  ====================
  The issue has been assigned CVE-2013-4494.
  NOTE REGARDING LACK OF EMBARGO
  ==============================
  While the response to this issue was being prepared by the security
  team, the bug was independently discovered by a third party who
  publicly disclosed it without realising the security impact.
  ISSUE DESCRIPTION
  =================
  The locks page_alloc_lock and grant_table.lock are not always taken in
  the same order.  This opens the possibility of deadlock.
  IMPACT
  ======
  A malicious guest administrator can deny service to the entire host.
  VULNERABLE SYSTEMS
  ==================
  Xen versions going back to at least Xen 3.2 are vulnerable.
  To exploit the vulnerability, the attacker must have control of more
  than one vcpu, either by controlling a malicious multi-vcpu guest, or
  by controlling more than one guest.
  MITIGATION
  ==========
  There is no practical mitigation for this issue.
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Reviewed-by: Keir Fraser <keir@xen.org>
  Tested-by: Matthew Daley <mattjd@gmail.com>
  commit: 96b59ae2dcaa639a4f58c68f122f8ba8738009dc
  Signed-off-by: Boris Ostrovsky <boris.ostrovsky@oracle.com> [bug 18049441]  

* Thu Jan 02 2014 Adnan Misherfi <adnan.misherfi@oracle.com> - 4.3.0-22 
- Use -q with sysctl, to to not display the values set to stdout [bug 18007687]  

* Fri Dec 20 2013 Konrad Wilk <konrad.wilk@oracle.com> - 4.3.0-21 
- xend: Fix xm list bug reporting incorrect memory size
  From: Marcos Matsunaga <Marcos.Matsunaga@oracle.com>
  This change allows xend to double-check the xcinfo info (which
  hypercall it had already do) and use the up-to-date contents.
  'xl' already does this by using the xcinfo.
  Signed-off-by: Marcos Matsunaga <Marcos.Matsunaga@oracle.com>
  Signed-off-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com> [bug 14553104] [bug (] [bug MEM(K)] [bug IN] [bug XENTOP] [bug MISMATCH] [bug MEMTOTAL] [bug IN] [bug /PROC/MEMINFO] [bug AND] [bug MEM] [bug IN] [bug "XM] [bug LIST")]  

* Tue Dec 17 2013 Konrad Wilk <konrad.wilk@oracle.com> - 4.3.0-20 
- Xen: Spread boot time page scrubbing across all available CPU's
  The page scrubbing is done in 128MB chunks in lockstep across all the CPU's.
  This allows for the boot CPU to hold the heap_lock whilst each chunk is being
  scrubbed and then release the heap_lock when all CPU's are finished scrubing
  their individual chunk. This allows for the heap_lock to not be held
  continously and for pending softirqs are to be serviced periodically across
  all CPU's.
  The page scrub memory chunks are allocated to the CPU's in a NUMA aware
  fashion to reduce Socket interconnect overhead and improve performance.
  This patch reduces the boot page scrub time on a 128GB 64 core AMD Opteron
  6386 machine from 49 seconds to 3 seconds.
  Changes in v2
  - Reduced default chunk size to 128MB
  - Added code to scrub NUMA nodes with no active CPU linked to them
  - Be robust to boot CPU not being linked to a NUMA node
  Signed-off-by: Malcolm Crossley <malcolm.crossley@citrix.com>
  Signed-off-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com>
  Acked-by: Adnan Misherfi <adnan.misherfi@oracle.com> [bug 17962921]  

* Mon Dec 16 2013 Joe Jin <joe.jin@oracle.com> - 4.3.0-19 
- Xend: handle died domain in getVCPUInfo()
  When created new guest on NUMA server, xend tried to get the best node
  by calculated all vcpus info, if domain already be terminated then
  getVCPUInfo() will throw below exception and guest start failed:
  [2013-09-04 20:01:26 6254] ERROR (XendDomainInfo:496) VM start failed
  Traceback (most recent call last):
  File "/usr/lib64/python2.4/site-packages/xen/xend/XendDomainInfo.py", line 482, in start
  XendTask.log_progress(31, 60, self._initDomain)
  File "/usr/lib64/python2.4/site-packages/xen/xend/XendTask.py", line 209, in log_progress
  retval = func(*args, **kwds)
  File "/usr/lib64/python2.4/site-packages/xen/xend/XendDomainInfo.py", line 2918, in _initDomain
  node = self._setCPUAffinity()
  File "/usr/lib64/python2.4/site-packages/xen/xend/XendDomainInfo.py", line 2835, in _setCPUAffinity
  best_node = find_relaxed_node(candidate_node_list)[0]
  File "/usr/lib64/python2.4/site-packages/xen/xend/XendDomainInfo.py", line 2803, in find_relaxed_node
  cpuinfo = dom.getVCPUInfo()
  File "/usr/lib64/python2.4/site-packages/xen/xend/XendDomainInfo.py", line 1600, in getVCPUInfo
  raise XendError(str(exn))
  XendError: (3, 'No such process')
  This patch will check return value of xc.vcpu_getinfo() and make sure the
  error not caused by domain died before throw the exception.
  Signed-off-by: Joe Jin <joe.jin@oracle.com>
  Acked-by: Matt Wilson <msw@amazon.com>
  Acked-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com>
  Oracle-bug: 16819966 

* Wed Dec 11 2013 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.3.0-18 
- reduce minimum restart time to 10 seconds
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com> 

* Tue Dec 10 2013 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.3.0-17 
- as we move to loop from dm-nfs, revert commit 6370
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com> 

* Wed Dec 04 2013 Firas Azar <firas.azar@oracle.com> - 4.3.0-16 
- Oracle-bug: 17892410
  Signed off by: Adnan G Misherfi 

* Mon Nov 25 2013 Adnan Misherfi <adnan.misherfi@oracle.com> - 4.3.0-15 
- This patch fixes a crash in guests 2.6.32 when PLE is enabled. It has not made upstream yet,
  and we missed it in xen 4.3. There are two changes in this patch,  xen/arch/x86/hvm/vpt.c,
  and xen/arch/x86/hvm/vmx/vmcs.c. The changes in vmcs.c is not needed as it is already xen in 4.3 

* Mon Nov 18 2013 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.3.0-14 
- Restore C xenstored and put tdb to tmpfs.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com> 

* Tue Nov 05 2013 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.3.0-13 
- update to 4.3.1
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com> 

* Fri Oct 25 2013 Carson Hovey <carson.hovey@oracle.com> - 4.3.0-12 
- Requests to connect on port 8003 with a Med strength cipher are now rejected.
  See also Bugs 16721961, 16721654
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com> 

* Mon Oct 21 2013 Carson Hovey <carson.hovey@oracle.com> - 4.3.0-11 
- Add "allowhugepage" flag as a synonym for "allowsuperpage"
  for compatibility with previous releases.
  Signed-off-by: Dave McCracken <dave.mccracken@oracle.com>
  Acked-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com>
  Acked-by: Adnan Misherfi <adnan.misherfi@oracle.com> [bug 13821795] 
- Requests to connect on port 8003 with a LOW/weak cipher are now rejected.
  Signed-off-by: Cathy A. Avery <cathy.avery@oracle.com>;
  Oracle-bug: 16721961 - SECURE LIVE MIGRATION PORT ALLOWS WEAK CIPHER CONNECTION 

* Fri Oct 11 2013 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.3.0-10 
- Add vif-switch to the makefile so that it is put in the xen scripts
  directory. [bug 15886237] 
- Disable netfilter on bridges. [bug 15871028] 
- Disable bridge multicast_snooping: Linux bridge can not forward packets
  to its ports and it is not needed.
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com> [bug 16746299]  

* Fri Oct 11 2013 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.3.0-9 
- Put back the patch that prevents older guests that use kudzu from
  hanging on reboot. Fixed the patch to prevent excessive watcher writes
  which causes xend, xenstored to run at a 100% cpu usage. Now the watch
  is written only if the console in Initialising, InitWait, Initialised
  states which happen once at boot time.
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com> [bug 13523487] 
- Disable iptables when adding a VIF to a Bridge.
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com> [bug 14611657] 
- Add support for openvswitch.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com> 

* Fri Oct 11 2013 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.3.0-8 
- Remove unnecessary balloon retries on vm creation.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com> [bug 14143327] 
- Expose host uuid to guest via xenstore.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com>
- Revert change set 22315 because it breaks live migration:
  Do not wait for memory teardown when live migrate
  When trying to live migrate guest with great memory (e.g. 20 GB),
  there's delay caused by destroying source copy of domain. To speed up
  this process we can close socket before starting guest destroy, as
  source guest is not running anymore.
  Signed-off-by: Miroslav Rezanina <mrezanin@redhat.com>
  Signed-off-by: Ian Jackson <ian.jackson@eu.citrix.com> [bug 13808326] [bug 13874471]  

* Fri Oct 11 2013 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.3.0-7 
- Fix xm create vcpu_avail exceeds XMLRPC int limits.
  If maxvcpus = vcpus = 40, (1<<40 -1) will exceed XMLRPC int limit.
  Changing it to str will work. Then in the xend side, it will be
  converted back to int.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com> [bug 14473041] 
- Fix bootloader hang/crash xend on wrong bootargs.
  When dom0 under heavy pressure, the pipe read in xen bootloader may
  return -EAGAIN. This may result in no data read or partial data read.
  With this patch, bootloader will read again when that happens.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com>
  Signed-off-by: Steve Prochniak <steve.prochniak@oracle.com> [bug 14195864] [bug 14325570] [bug 14268749] [bug 14527250] 
- Create a loop device node if it does not exist on VM start.
  After this patch, kernel max_loop could be 8.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com> 

* Fri Oct 11 2013 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.3.0-6 
- Add "OVM" to version information. This is visible through
  smbios/dmidecode information for HVM guests. [bug 11792774] 
- Fix xm reboot wait exception.
  For VM reboot, the VM will first shutdown and then xend will recreate
  it. This bug is caused by: when we do server.xend.domains(), the VM is
  live; when we do server.xend.domain.getRestartCount(), the VM is dead,
  thus raise an exception.
  We can ignore this exception and just continue: this domain will be
  handled in the next loop (it will not in the live vm list).
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com>
  Signed-off-by: Jingjie Jiang <jingjie.jiang@oracle.com>
  Signed-off-by: Junjie Wei <junjie.wei@oracle.com> [bug 14836200] 
- xend: disable SCSI device discover during xend start.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com> [bug 14538564]  

* Fri Oct 11 2013 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.3.0-5 
- Enable Xend SSL relocation server.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com>
- Disable ballooning of dom0. [bug 8604766] [bug 9485681] 
- Disable network-script.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com> 

* Fri Oct 11 2013 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.3.0-4 
- Fix file descriptor leak in SSL migration.
  Signed-off-by: Steve Prochniak <steve.prochniak@oracle.com
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com>
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com> [bug 16706361] 
- Setup dmnfs device mapper for files on NFS.
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com>
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
- Avoid ballooning when dom0-min-mem is set and enable-dom0-ballooning is
  enabled.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com> [bug 12404026]  

* Fri Oct 11 2013 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.3.0-3 
- Add domain running lock callout hook.
  
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Junjie Wei <junjie.wei@oracle.com>
- Set max cstate to 1.
  
  Signed-off-by: Joe Jin <joe.jin@oracle.com>
   [bug 13703504] 
- xen: increase default max grant frames from 32 to 64.
  We advertise as being able to launch 32VIFs and 8 VBDs.
  But currently the amount of frames that a guest uses is
  based on this simple algebra:
  #vifs + 2/3*#vbds <= 32
  So if we have 31VIFs we cannot have any more VBDs nor any
  more VIFs. By increasing the value to 64 we have some extra
  headroom _and_ we can have at least 8VBDs (or more).
  Acked-by: Adnan Misherfi <adnan.misherfi@oracle.com>
  Signed-off-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com> [bug 16039922] 
- Avoid concurrent calls to destory() for the same domain.
  Signed-off-by: Joe Jin <joe.jin@oracle.com>
  Reviewed-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com>
  Reviewed-by: Adnan Misherfi <adnan.misherfi@oracle.com> [bug 16098765]  

* Fri Oct 11 2013 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.3.0-2 
- Use local qemu insead of downloading.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
- In bootloader(), domains_lock is first released to avoid a stunk
  bootloder from denying service to the other xend clients. It is
  re-acquired before returning to domain creation to cover the changes
  to be made. But if something goes wrong and domains_lock is not
  re-acquired, we may hit an error when releasing it one more time.
  This patch makes sure that the released domains_lock is re-acquired
  before returning.
  Signed-off-by: Junjie Wei <junjie.wei@oracle.com>
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com> [bug 14407719]  

* Thu Aug 29 2013 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.3.0-1 
- rebuild for 4.3.0
